#include "count99.h"

int sparse[0x100][0x100];

bool Count99::counting(char *file_name, int columnCount) {
    using namespace std;

    bool too_short = false;
    char *b0;
    char *b1;
    const int c[10] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9'};
    int count, k, lineEnd, lineLength, m, n, standardLine, u, w;

    ifstream in(file_name);
    if( in.fail() ) {
        const string FILE_NAME(file_name);
        error = "e1: ifstream in( " + FILE_NAME + CLOSE_BRACKET;
        return false;
    }

    standardLine = columnCount * COUNT_NUMBER_SIZE;
    while( in.getline(buffer, COUNT_BUFFER_SIZE) ) {
        lineLength = strlen(buffer);
        if(lineLength == standardLine) {
            b0 = & buffer[0];
            b1 = & buffer[1];
            for(k = 0; k < columnCount; ++k) {
// Accessing and incrementing the matrix element
                count = sparse[ *b0 ][ *b1 ];
                sparse[ *b0 ][ *b1 ] = count + 1;

                b0 += COUNT_NUMBER_SIZE;
                b1 += COUNT_NUMBER_SIZE;
            }

        } else {
            too_short = true;
            break;
        }

    }

    if(too_short) {
        lineEnd = false;
        b0 = & buffer[0];
        b1 = & buffer[1];

        for(n = 0; n < columnCount; ++n) {
// Accessing and incrementing the matrix element
            count = sparse[ *b0 ][ *b1 ];
            sparse[ *b0 ][ *b1 ] = count + 1;
            for(m = 0; m < COUNT_NUMBER_SIZE; ++m) {
                ++b0;
                if(*b0 == '\0') {
                    lineEnd = true;
                    break;
                }

                ++b1;
                if(*b1 == '\0') {
                    lineEnd = true;
                    break;
                }

            }

            if(lineEnd) {
                break;
            }

        }

    }

    in.close();
    stringstream os;
    for(u = 0; u < 10; ++u) {
        for(w = 0; w < 10; ++w) {
            os << u << w << ": " << sparse[ c[u] ][ c[w] ] << NEW_LINE;
        }

    }

    data = os.str();
    return true;
}

bool Count99::mean(char *file_name, int columnCount) {
    using namespace std;

    bool too_short = false;
    char *b0;
    char *b1;
    char *stop;
    char c[3] = {'0', '1', '\0'};
    int count = 0;
    int k, lineEnd, lineLength, standardLine;
    int sum = 0;

    ifstream in(file_name);
    if( in.fail() ) {
        const string FILE_NAME(file_name);
        error = "e2: ifstream in( " + FILE_NAME + CLOSE_BRACKET;
        return false;
    }

    standardLine = columnCount * COUNT_NUMBER_SIZE;
    while( in.getline(buffer, COUNT_BUFFER_SIZE) ) {
        lineLength = strlen(buffer);
        if(lineLength == standardLine) {
            b0 = & buffer[0];
            b1 = & buffer[1];
            for(int i = 0; i < columnCount; ++i) {
                c[0] = *b0;
                c[1] = *b1;
                k = (int)strtol(c, &stop, 10);
                count += 1;
                sum += k;

                b0 += COUNT_NUMBER_SIZE;
                b1 += COUNT_NUMBER_SIZE;
            }

        } else {
            too_short = true;
            break;
        }

    }

    if(too_short) {
        lineEnd = false;
        b0 = & buffer[0];
        b1 = & buffer[1];

        for(int i = 0; i < columnCount; ++i) {
            c[0] = *b0;
            c[1] = *b1;
            k = (int)strtol(c, &stop, 10);
            sum += k;
            for(int m = 0; m < COUNT_NUMBER_SIZE; ++m) {
                ++b0;
                if(*b0 == '\0') {
                    lineEnd = true;
                    break;
                }

                ++b1;
                if(*b1 == '\0') {
                    lineEnd = true;
                    break;
                }

            }

            if(lineEnd) {
                break;
            }

        }

    }

    in.close();
    double su = (double)sum;
    double co = (double)count;
    double d = su/co;

    stringstream os;
    os << "mean = " << d << NEW_LINE;
    data = os.str();
    return true;
}

bool Count99::preediting(std::string & pathName, char *file_name) {
    using namespace std;

// Reading ANNUY_TEXT to produce a file that has 8 columns.
    char c[TO_BUFFER_SIZE];
    char to[TO_BUFFER_SIZE];
    const int NUMBER_COUNT = 8; // ANNUY_TEXT
    const string FILE_NAME(file_name);
    ifstream in(file_name);
    if( in.fail() ) {
        error = "e4: ifstream in( " + FILE_NAME + CLOSE_BRACKET;
        return false;
    }

    ofstream file( pathName.c_str() );
    if( file.fail() ) {
        error = "e5: ofstream file( " + pathName + CLOSE_BRACKET;
        return false;
    }

    while( in.getline(c, TO_BUFFER_SIZE) ) {
        reduce_non_number_sequences(c, to, NUMBER_COUNT);
        file << to << endl;
    }

    file.close();
    return true;
}

bool Count99::variance(double mean, char *file_name, int columnCount) {
    using namespace std;

    bool too_short = false;
    char *b0;
    char *b1;
    char *stop;
    char c[5] = {'0', '1', '.', '0', '\0'};
    double d, w;
    double sum = 0.0;
    int count = 0;
    int lineEnd, lineLength, standardLine;

    ifstream in(file_name);
    if( in.fail() ) {
        const string FILE_NAME(file_name);
        error = "e3: ifstream in( " + FILE_NAME + CLOSE_BRACKET;
        return false;
    }

    standardLine = columnCount * COUNT_NUMBER_SIZE;
    while( in.getline(buffer, COUNT_BUFFER_SIZE) ) {
        lineLength = strlen(buffer);
        if(lineLength == standardLine) {
            b0 = & buffer[0];
            b1 = & buffer[1];
            for(int i = 0; i < columnCount; ++i) {
                c[0] = *b0;
                c[1] = *b1;
                d = strtod(c, &stop);
                w = (d - mean) * (d - mean);
                count += 1;
                sum += w;

                b0 += COUNT_NUMBER_SIZE;
                b1 += COUNT_NUMBER_SIZE;
            }

        } else {
            too_short = true;
            break;
        }

    }

    if(too_short) {
        lineEnd = false;
        b0 = & buffer[0];
        b1 = & buffer[1];

        for(int i = 0; i < columnCount; ++i) {
            c[0] = *b0;
            c[1] = *b1;
            d = strtod(c, &stop);
            w = (d - mean) * (d - mean);
            count += 1;
            sum += w;

            for(int m = 0; m < COUNT_NUMBER_SIZE; ++m) {
                ++b0;
                if(*b0 == '\0') {
                    lineEnd = true;
                    break;
                }

                ++b1;
                if(*b1 == '\0') {
                    lineEnd = true;
                    break;
                }

            }

            if(lineEnd) {
                break;
            }

        }

    }

    in.close();
    double co = (double)count;
    d = sum/co;

    stringstream os;
    os << "variance = " << d << NEW_LINE;
    data = os.str();
    return true;
}

Count99::Count99(): CLOSE_BRACKET(" )"), COUNT_ERROR(-1), EMPTY(""), NEW_LINE("\x0D\x0A") {
    memset(sparse, 0, 0x100 * 0x100);
}

int Count99::countingColumns(char *file_name) {
    using namespace std;

    int columnCount;
    ifstream in(file_name);
    if( in.fail() ) {
        const string FILE_NAME(file_name);
        error = "e9: ifstream in( " + FILE_NAME + CLOSE_BRACKET;
        return COUNT_ERROR;
    }

    char buffer[TO_BUFFER_SIZE];
    if( in.getline(buffer, TO_BUFFER_SIZE) ) {
        in.close();

        int lineLength = strlen(buffer);
        columnCount = lineLength/COUNT_NUMBER_SIZE;
    } else {
        const string BUFFER_ERROR(buffer);
        error = "e10: in.getline( " + BUFFER_ERROR + ", TO_BUFFER_SIZE)";
        return COUNT_ERROR;
    }

    return columnCount;
}

std::string Count99::tabulating(double m, char *file_name, int columnCount, bool analysis, bool arithmetic) {
    using namespace std;

    const string FILE_NAME(file_name);
    stringstream os;

    if(arithmetic) {
// arithmetic mean
        if( mean(file_name, columnCount) ) {
            os << data << NEW_LINE;
        } else {
            error = "e6: mean( " + FILE_NAME + " , columnCount)";
            createErrorText(error);
            return EMPTY;
        }

    } else {
        if(analysis) {
// Using m (expectation or arithmetic mean) to calculate the variance
            if( variance(m, file_name, columnCount) ) {
                os << data << NEW_LINE;
            } else {
                error = "e7: variance(m, " + FILE_NAME + " , columnCount)";
                createErrorText(error);
                return EMPTY;
            }

        }

    }

    if( counting(file_name, columnCount) ) {
        os << data << NEW_LINE;
    } else {
        error = "e8: counting( " + FILE_NAME + " , columnCount)";
        createErrorText(error);
        return EMPTY;
    }

    string s = os.str();
    return s;
}

void Count99::reduce_non_number_sequences(char *p, char *to, int number_count) {
/*
05 06 14 /17 25 /29 31 38 // -123
05 06 14 17 25 29 31 38 123
number_count = 9
*/
    char *from;
    const int GAP_C = 0x20;
    const int GAP_SIZE = 1;
    int cycle, i, n, u;

    for(i = 0; i < number_count; ++i) {
        n = strspn(p, "0123456789");
        from = p;
        p += n;

        u = strcspn(p, "0123456789");
        p += u;

        strncpy(to, from, n);
        *(to + n) = GAP_C;
        cycle = n + GAP_SIZE;
        to += cycle;
    }

    *to = '\0';
}
