/*
rannu VCL Version 1.04
Producing random-number tables
Copyright 2017 Sogaya

Borland C++Builder 5

*/

#include <string>
#include <vcl.h>
#include "rannu.h"
#pragma hdrstop
USERES("rannu.res");
USEFORM("rannuMain.cpp", Form1);
USEFORM("C:\BORLAND\CBUILDER5\OBJREPOS\OKCANCL2.cpp", OKRightDlg);
USEFORM("rannuVersion.cpp", OKHelpRightDlg);
USEFORM("rannuManage.cpp", OKRightDlg1);
USEUNIT("OS-specific.cpp");
USEUNIT("Numbered.cpp");
USEUNIT("Dividing.cpp");
USEUNIT("MT.cpp");
USEUNIT("mt19937ar.cpp");
USEUNIT("OutputNewLine.cpp");
USEUNIT("rannuText.cpp");
USEUNIT("Xorshift.cpp");
USEUNIT("Count99.cpp");

extern MANAGE_MEMO *mm;

namespace {
    using namespace std;

    const string RANNU_TEXT("rannu.txt");
    const string ZERO("0");
    const int MERSENNE_TWISTER = 1;
    const int XORSHIFT = 6;

    bool csv, grouping, produce_rannu_text, showWhere;
    string error, FULL_PATH_NAME, pathName;
    int from, interval_0, interval_1, lineCount, rannu_h, rannu_w, rannu_x, rannu_y, prng, whichCorner;
    long kilo, seed;

    const string m0(          ""); // m[0], FULL_PATH_NAME includes MANAGE_TEXT.
    const string m1(         "0"); // m[1], csv: RANNU_CSV
    const string m2(      "C:\\"); // m[2], pathName includes the directory name (C:\) and RANNU_TEXT.
    const string m3(        "32"); // m[3], kilo: RANNU_TEXT size (kilobytes, KB)
    const string m4(         "1"); // m[4], interval_0: Loto-7
    const string m5(        "37"); // m[5], interval_1: Loto-7
    const string m6(         "0"); // m[6], grouping: interval of 0-63
    const string m7(       "400"); // m[7], from: idling
    const string m8(    "123456"); // m[8], seed: pseudorandom number generator (PRNG)
    const string m9("2147483647"); // m[9]
}

bool readFilesBeforeCreatingWindows(std::string & commandLine) {
    using namespace std;

    char *stop;
    const bool WITH_COMMENTS = true;
    const bool WITHOUT_COMMENTS = false;
    const string BINGO_5 = "-b";
    const string EMPTY = "";
    const string FROM_TERM = "-f"; // idling
    const string GROUPING = "-g";
    const string INTERVAL = "-i";
    const string KILOBYTE_TERM = "-k";
    const string LINES = "-L";
    const string LOTO_6 = "-6";
    const string LOTO_7 = "-7";
    const string MINILOTO = "-m";
    const string PRNG_MT = "-pm";
    const string PRNG_XORSHIFT = "-px";
    const string REGARDLESS_OF_LINES = "-L-";
    const string SEED_TERM = "-s";
    const string version_comments = "-VC";
    const string version_guide = "-V";
    const string WHERE("-w");
    const int ERROR_CODE = 1;

    int q;
    Numbered *n = new Numbered("");
    string *p = new string("");
    string argument;
    string manage_text_name(MANAGE_TEXT);
    string m[ MANAGE_TEXT_LINE_COUNT + 1 ];
    m[0] = m0; m[1] = m1; m[2] = m2; m[3] = m3; m[4] = m4; m[5] = m5; m[6] = m6; m[7] = m7; m[8] = m8; m[9] = m9;
    prng = MERSENNE_TWISTER; // MT
    produce_rannu_text = true;

// C:\rannuVCL\manage.txt for example
    string firstPart = currentDirectory(); // OS-specific.h and OS-specific.cpp
    NAMES a = driveDirectoryBase(firstPart);
    string SEPARATOR = a.separator;
    string root = a.name[1];
    if(firstPart == root) { // C:\ for example
        FULL_PATH_NAME = root + manage_text_name;
    } else { // C:\rannuVCL for example
        FULL_PATH_NAME = firstPart + SEPARATOR + manage_text_name;
    }

    ifstream file( FULL_PATH_NAME.c_str() );
    if( file.fail() ) { // MANAGE_TEXT
// Creating MANAGE_TEXT
        ofstream manage_text( FULL_PATH_NAME.c_str() );
        for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1 ) {
            manage_text << m[line] << endl;
        }

        return ERROR_CODE;
    } else {
        file.close();
    }

// Reading MANAGE_TEXT
    char c[BUFFER_SIZE];
    ifstream in( FULL_PATH_NAME.c_str() );
    m[0] = FULL_PATH_NAME;
    for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1) {
        if( in.getline(c, BUFFER_SIZE) ) {
            delete p;
            p = new string(c);
            m[line] = *p;
        } else {
            break;
        }

    }

    in.close();
    csv = (ZERO == m[1]) ? false : true;
    pathName = m[2] + RANNU_TEXT;
    kilo = strtol( m[3].c_str(), &stop, 10);
    const long based_on_m3 = kilo;

    interval_0 = stringToInteger(m[4]);
    const int based_on_m4 = interval_0;

    interval_1 = stringToInteger(m[5]);
    const int based_on_m5 = interval_1;

    grouping = (ZERO == m[6]) ? false : true;
    from = stringToInteger(m[7]);
    const int based_on_m7 = from;

    seed = strtol( m[8].c_str(), &stop, 10);
    const long based_on_m8 = seed;

    lineCount = stringToInteger(m[9]);
    const int based_on_m9 = lineCount;

    rannu_h = MAIN_HEIGHT;
    rannu_w = MAIN_WIDTH;
    rannu_x = MAIN_X;
    rannu_y = MAIN_Y;

    char r[SMALL_BUFFER_SIZE];
    Dividing d(commandLine);
    const int FIELD_COUNT = d.fieldCount();
    for(int i = 1; i < FIELD_COUNT; ++i) {
        argument = d.a(i);
        if( argument.length() == 0 ) {
            break;
        }

        if(argument == BINGO_5) {
            interval_1 = 40;
        } else if(argument == GROUPING) {
            grouping = true;
        } else if(argument == LOTO_6) {
            interval_1 = 43;
        } else if(argument == LOTO_7) {
            interval_1 = 37;
        } else if(argument == MINILOTO) {
            interval_1 = 31;
        } else if(argument == PRNG_MT) {
            prng = MERSENNE_TWISTER;
        } else if(argument == PRNG_XORSHIFT) {
            prng = XORSHIFT;
        } else if(argument == REGARDLESS_OF_LINES) {
            lineCount = LARGE_NUMBER;
        } else if(argument == version_guide) {
            guide(WITHOUT_COMMENTS);
            delete n; delete p;
            return false;
        } else if(argument == version_comments) {
            guide(WITH_COMMENTS);
            delete n; delete p;
            return false;
        } else if(argument == WHERE) {
            showWhere = true;
        } else {
            q = argument.find(FROM_TERM);
			if(q != string::npos) {
                delete n;
                strcpy(r, argument.c_str() );
                n = new Numbered(r);
                from = n->number();
                if( n->parameter() == FROM_TERM ) {
                    continue;
                }

                from = based_on_m7;
            }

            q = argument.find(INTERVAL);
			if(q != string::npos) {
                delete n;
                strcpy(r, argument.c_str() );
                n = new Numbered(r);
                interval_1 = n->number();
                if( n->trimmed_sequence() ) {
                    interval_0 = n->subnumber();
                    if( n->parameter() == INTERVAL ) {
                        continue;
                    }

                }

                interval_0 = based_on_m4;
                interval_1 = based_on_m5;
            }

            q = argument.find(KILOBYTE_TERM);
			if(q != string::npos) {
                delete n;
                strcpy(r, argument.c_str() );
                n = new Numbered(r);
                kilo = (long) n->number();
                if( n->parameter() == KILOBYTE_TERM ) {
                    continue;
                }

                kilo = based_on_m3;
            }

            q = argument.find(LINES);
			if(q != string::npos) {
                delete n;
                strcpy(r, argument.c_str() );
                n = new Numbered(r);
                lineCount = n->number();
                if( n->parameter() == LINES ) {
                    continue;
                }

                lineCount = based_on_m9;
            }

            q = argument.find(SEED_TERM);
			if(q != string::npos) {
                delete n;
                strcpy(r, argument.c_str() );
                n = new Numbered(r);
                seed = (long) n->number();
                if( n->parameter() == SEED_TERM ) {
                    continue;
                }

                seed = based_on_m8;
            }

        }

    }

    delete n;
    if(grouping) {
        interval_0 = 0;
        interval_1 = 63;
    }

    mm->csv = csv;
    mm->from = from;
    mm->FULL_PATH_NAME = FULL_PATH_NAME;
    mm->grouping = grouping;
    mm->interval_0 = interval_0;
    mm->interval_1 = interval_1;
    mm->kilo = kilo;
    mm->lineCount = lineCount;
    mm->pathName = pathName;
    mm->pleaseCheck = true;
    mm->prng = prng;
    mm->produce_rannu_text = produce_rannu_text;
    mm->rannu_h = rannu_h;
    mm->rannu_w = rannu_w;
    mm->rannu_x = rannu_x;
    mm->rannu_y = rannu_y;
    mm->seed = seed;
    mm->showWhere = showWhere;

    return true;
}

WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
    std::string command( ::GetCommandLine() );
    if( readFilesBeforeCreatingWindows(command) ) {
        ;
    } else {
        return 0;
    }

    try
    {
         Application->Initialize();
         Application->HelpFile = "C:\\rannuVCL\\rannu.hlp";
         Application->Title = "Rannu";
         Application->CreateForm(__classid(TForm1), &Form1);
         Application->CreateForm(__classid(TOKHelpRightDlg), &OKHelpRightDlg);
         Application->CreateForm(__classid(TOKRightDlg1), &OKRightDlg1);
         Application->Run();
    }
    catch (Exception &exception)
    {
         Application->ShowException(&exception);
    }
    return 0;
}

void guide(bool comments) {
    using namespace std;

    if(comments) {
        ofstream file(VERSION_TEXT);
        file << "rannu VCL Version " << VERSION << " \n" << endl 
            << "rannu        # Show the Rannu window. " << endl 
            << "rannu -6     # Loto-6 " << endl 
            << "rannu -7     # Loto-7 " << endl 
            << "rannu -b     # Bingo-5 " << endl 
            << "rannu -f400  # idling " << endl 
            << "rannu -g     # interval of 0 to 63 " << endl 
            << "rannu -i1-37 # interval of 1 to 37 " << endl 
            << "rannu -k32   # 32 kilobytes " << endl 
            << "rannu -L20   # 20 lines " << endl 
            << "rannu -L-    # Produce rannu.txt regardless of lines. " << endl 
            << "rannu -m     # Miniloto " << endl 
            << "rannu -pm    # MT " << endl 
            << "rannu -px    # xorshift " << endl 
            << "rannu -s123456 # seed " << endl 
            << "rannu -s0    # Time is used as seed. " << endl 
            << "rannu -V     # version " << endl 
            << "rannu -VC    # version with comments " << endl 
            << "rannu -w     # Show where the cursor is. " << endl;
    } else {
        ofstream file(VERSION_TEXT);
        file << "rannu VCL Version " << VERSION << " \n" << endl 
            << "rannu        " << endl 
            << "rannu -6     " << endl 
            << "rannu -7     " << endl 
            << "rannu -b     " << endl 
            << "rannu -f400  " << endl 
            << "rannu -g     " << endl 
            << "rannu -i1-37 " << endl 
            << "rannu -k32   " << endl 
            << "rannu -L20   " << endl 
            << "rannu -L-    " << endl 
            << "rannu -m     " << endl 
            << "rannu -pm    " << endl 
            << "rannu -px    " << endl 
            << "rannu -s123456 " << endl 
            << "rannu -s0    " << endl 
            << "rannu -V     " << endl 
            << "rannu -VC    " << endl 
            << "rannu -w     " << endl;
    }

}
