#include <vcl.h>
#pragma hdrstop

#include "NAMES.h"
#include "OS-specific.h"
#include "rannuManage.h"

#pragma resource "*.dfm"

extern MANAGE_MEMO *mm;
TOKRightDlg1 *OKRightDlg1;

namespace {
    using namespace std;

    const string m0(          ""); // m[0], FULL_PATH_NAME includes MANAGE_TEXT.
    const string m1(         "0"); // m[1], csv: RANNU_CSV
    const string m2(      "C:\\"); // m[2], pathName includes the directory name (C:\) and RANNU_TEXT.
    const string m3(        "32"); // m[3], kilo: RANNU_TEXT size (kilobytes, KB)
    const string m4(         "1"); // m[4], interval_0: Loto-7
    const string m5(        "37"); // m[5], interval_1: Loto-7
    const string m6(         "0"); // m[6], grouping: interval of 0-63
    const string m7(       "400"); // m[7], from: idling
    const string m8(    "123456"); // m[8], seed: pseudorandom number generator (PRNG)
    const string m9("2147483647"); // m[9], lineCount: the first part of file
}

bool TOKRightDlg1::readManageText() {
    using namespace std;

    char c[BUFFER_SIZE];
    string *p = new string("");
    ifstream in( FULL_PATH_NAME.c_str() );
    if( in.fail() ) {
        error = "e14: ifstream in( " + FULL_PATH_NAME + CLOSE_BRACKET;
        createErrorText(error);
        return false;
    }

    m[0] = FULL_PATH_NAME;
    for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1) {
        if( in.getline(c, BUFFER_SIZE) ) {
            delete p;
            p = new string(c);
            m[line] = *p;
        } else {
            break;
        }

    }

    in.close();
    delete p;
    return true;
}

bool TOKRightDlg1::writeManageText() {
    using namespace std;

    char *stop;
    char buffer[SMALL_BUFFER_SIZE];
    int q;

    m[0] = FULL_PATH_NAME;
    m[1] = csv ? ONE : ZERO;

    const AnsiString EDIT_FIELD_1 = Memo1->Text;
    string PATH_NAME( EDIT_FIELD_1.c_str() );
    q = PATH_NAME.find(NEW_LINE);
    if(q != string::npos) {
        PATH_NAME = PATH_NAME.substr(0, q);
    }

    if(csv) {
        pathName = PATH_NAME + RANNU_CSV;
    } else {
        pathName = PATH_NAME + RANNU_TEXT;
    }

    m[2] = PATH_NAME; // root + directory

    const AnsiString EDIT_FIELD_2 = Memo2->Text;
    string KILO( EDIT_FIELD_2.c_str() );
    q = KILO.find(NEW_LINE);
    if(q != string::npos) {
        KILO = KILO.substr(0, q);
    }

    kilo = strtol( KILO.c_str(), &stop, 10);
    m[3] = KILO;

    const AnsiString EDIT_FIELD_4 = Edit4->Text;
    string INTERVAL_0( EDIT_FIELD_4.c_str() );
    interval_0 = stringToInteger(INTERVAL_0);
    m[4] = INTERVAL_0;

    const AnsiString EDIT_FIELD_5 = Edit5->Text;
    string INTERVAL_1( EDIT_FIELD_5.c_str() );
    interval_1 = stringToInteger(INTERVAL_1);
    m[5] = INTERVAL_1;

    grouping = false;
    if(interval_1 == 63) {
        if(interval_0 == 0) {
            grouping = true;
        }

    }

    m[6] = grouping ? ONE : ZERO;

    const AnsiString EDIT_FIELD_6 = Edit6->Text;
    string FROM( EDIT_FIELD_6.c_str() );
    from = stringToInteger(FROM); // idling
    m[7] = FROM;

    const AnsiString EDIT_FIELD_7 = Edit7->Text;
    string SEED( EDIT_FIELD_7.c_str() );
    seed = strtol( SEED.c_str(), &stop, 10);
    m[8] = SEED;

    const AnsiString EDIT_FIELD_3 = Memo3->Text;
    string LINE_COUNT( EDIT_FIELD_3.c_str() );
    q = LINE_COUNT.find(NEW_LINE);
    if(q != string::npos) {
        LINE_COUNT = LINE_COUNT.substr(0, q);
    }

    lineCount = stringToInteger(LINE_COUNT);
    m[9] = LINE_COUNT;

// Creating MANAGE_TEXT
    ofstream manage_text( FULL_PATH_NAME.c_str() );
    for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1 ) {
        manage_text << m[line] << endl;
    }

    return true;
}

int stringToInteger(std::string & s) {
    using namespace std;

    int value;
    stringstream ss(s);
    ss >> value;
    return value;
}

__fastcall TOKRightDlg1::TOKRightDlg1(TComponent* AOwner)
	: TForm(AOwner), FULL_PATH_NAME("C:\\rannuVCL\\manage.txt"), CLOSE_BRACKET(" )"), NEW_LINE("\x0D\x0A"), ONE("1"), RANNU_CSV("rannu.csv"), RANNU_TEXT("rannu.txt"), ZERO("0")
{
// Where button
    Button1->Left = MANAGE_WHERE_BUTTON_LEFT;
    Button1->Top = MANAGE_WHERE_BUTTON_TOP;
    Button1->Width = BUTTON_WIDTH;
    Button1->Height = BUTTON_HEIGHT;

// Help button
    Button2->Left = MANAGE_BUTTON_LEFT;
    Button2->Top = MANAGE_HELP_BUTTON_TOP;
    Button2->Width = BUTTON_WIDTH;
    Button2->Height = BUTTON_HEIGHT;

// Close button
    CancelBtn->Left = MANAGE_BUTTON_LEFT;
    CancelBtn->Top = MANAGE_CLOSE_BUTTON_TOP;
    CancelBtn->Width = BUTTON_WIDTH;
    CancelBtn->Height = BUTTON_HEIGHT;

// Save button
    OKBtn->Left = MANAGE_BUTTON_LEFT;
    OKBtn->Top = MANAGE_SAVE_BUTTON_TOP;
    OKBtn->Width = BUTTON_WIDTH;
    OKBtn->Height = BUTTON_HEIGHT;

    Memo1->Left = MANAGE_DIRECTORY_LEFT;
    Memo1->Top = MANAGE_DIRECTORY_TOP;
    Memo1->Width = MANAGE_DIRECTORY_WIDTH;
    Memo1->Height = MANAGE_DIRECTORY_HEIGHT;

    Label1->Left = MANAGE_DIRECTORY_LABEL_LEFT;
    Label1->Top = MANAGE_DIRECTORY_LABEL_TOP;
    Label1->Width = MANAGE_DIRECTORY_LABEL_WIDTH;
    Label1->Height = MANAGE_DIRECTORY_LABEL_HEIGHT;

    Memo2->Left = MANAGE_KB_LEFT;
    Memo2->Top = MANAGE_KB_TOP;
    Memo2->Width = MANAGE_KB_WIDTH;
    Memo2->Height = MANAGE_KB_HEIGHT;

    Label2->Left = MANAGE_KB_LABEL_LEFT;
    Label2->Top = MANAGE_KB_LABEL_TOP;
    Label2->Width = MANAGE_KB_LABEL_WIDTH;
    Label2->Height = MANAGE_KB_LABEL_HEIGHT;

    Memo3->Left = MANAGE_LINES_LEFT;
    Memo3->Top = MANAGE_LINES_TOP;
    Memo3->Width = MANAGE_LINES_WIDTH;
    Memo3->Height = MANAGE_LINES_HEIGHT;

    Label3->Left = MANAGE_LINES_LABEL_LEFT;
    Label3->Top = MANAGE_LINES_LABEL_TOP;
    Label3->Width = MANAGE_LINES_LABEL_WIDTH;
    Label3->Height = MANAGE_LINES_LABEL_HEIGHT;

// The PRNG group includes from, to, idling, and seed text-fields.
    GroupBox1->Left = MANAGE_PRNG_LEFT;
    GroupBox1->Top = MANAGE_PRNG_TOP;
    GroupBox1->Width = MANAGE_PRNG_WIDTH;
    GroupBox1->Height = MANAGE_PRNG_HEIGHT;

    Edit4->Left = MANAGE_FROM_LEFT;
    Edit4->Top = MANAGE_FROM_TOP;
    Edit4->Width = MANAGE_FROM_WIDTH;
    Edit4->Height = MANAGE_FROM_HEIGHT;

    Label4->Left = MANAGE_FROM_LABEL_LEFT;
    Label4->Top = MANAGE_FROM_LABEL_TOP;
    Label4->Width = MANAGE_FROM_LABEL_WIDTH;
    Label4->Height = MANAGE_FROM_LABEL_HEIGHT;

    Edit5->Left = MANAGE_TO_LEFT;
    Edit5->Top = MANAGE_TO_TOP;
    Edit5->Width = MANAGE_TO_WIDTH;
    Edit5->Height = MANAGE_TO_HEIGHT;

    Label5->Left = MANAGE_TO_LABEL_LEFT;
    Label5->Top = MANAGE_TO_LABEL_TOP;
    Label5->Width = MANAGE_TO_LABEL_WIDTH;
    Label5->Height = MANAGE_TO_LABEL_HEIGHT;

    Edit6->Left = MANAGE_IDLING_LEFT;
    Edit6->Top = MANAGE_IDLING_TOP;
    Edit6->Width = MANAGE_IDLING_WIDTH;
    Edit6->Height = MANAGE_IDLING_HEIGHT;

    Label6->Left = MANAGE_IDLING_LABEL_LEFT;
    Label6->Top = MANAGE_IDLING_LABEL_TOP;
    Label6->Width = MANAGE_IDLING_LABEL_WIDTH;
    Label6->Height = MANAGE_IDLING_LABEL_HEIGHT;

    Edit7->Left = MANAGE_SEED_LEFT;
    Edit7->Top = MANAGE_SEED_TOP;
    Edit7->Width = MANAGE_SEED_WIDTH;
    Edit7->Height = MANAGE_SEED_HEIGHT;

    Label7->Left = MANAGE_SEED_LABEL_LEFT;
    Label7->Top = MANAGE_SEED_LABEL_TOP;
    Label7->Width = MANAGE_SEED_LABEL_WIDTH;
    Label7->Height = MANAGE_SEED_LABEL_HEIGHT;

    m[0] = m0; m[1] = m1; m[2] = m2; m[3] = m3; m[4] = m4; m[5] = m5; m[6] = m6; m[7] = m7; m[8] = m8; m[9] = m9; 
    setting();
}

void TOKRightDlg1::setting() {
    string s;
    stringstream *os = new stringstream();

// drive and directory
    pathName = mm->pathName;
    NAMES a = driveDirectoryBase(pathName);
    string root = a.name[1];
    string directory = a.name[2];
    path = root + directory;

    const AnsiString DRIVE_DIRECTORY( path.c_str() );
    Memo1->Text = DRIVE_DIRECTORY;

// RANNU_CSV or RANNU_TEXT
    csv = mm->csv;
    if(csv) {
        AnsiString BASE_NAME( RANNU_CSV.c_str() );
        Label1->Caption = BASE_NAME;
    } else {
        AnsiString BASE_NAME( RANNU_TEXT.c_str() );
        Label1->Caption = BASE_NAME;
    }

// kilobytes
    kilo = mm->kilo;
    delete os;
    os = new stringstream();
    *os << kilo;
    s = os->str();

    const AnsiString KILO( s.c_str() );
    Memo2->Text = KILO;

// lines
    lineCount = mm->lineCount;
    delete os;
    os = new stringstream();
    *os << lineCount;
    s = os->str();

    const AnsiString LINES( s.c_str() );
    Memo3->Text = LINES;

// from
    interval_0 = mm->interval_0;
    delete os;
    os = new stringstream();
    *os << interval_0;
    s = os->str();

    const AnsiString INTERVAL_0( s.c_str() );
    Edit4->Text = INTERVAL_0;

// to
    interval_1 = mm->interval_1;
    delete os;
    os = new stringstream();
    *os << interval_1;
    s = os->str();

    const AnsiString INTERVAL_1( s.c_str() );
    Edit5->Text = INTERVAL_1;

// idling
    from = mm->from;
    delete os;
    os = new stringstream();
    *os << from;
    s = os->str();

    const AnsiString FROM( s.c_str() );
    Edit6->Text = FROM;

// seed
    seed = mm->seed;
    delete os;
    os = new stringstream();
    *os << seed;
    s = os->str();

    const AnsiString SEED( s.c_str() );
    Edit7->Text = SEED;

    delete os;
}

void __fastcall TOKRightDlg1::Button1Click(TObject *Sender)
{
    if( OpenDialog1->Execute() ) {
        const AnsiString FILE_NAME = OpenDialog1->FileName;
        std::string pathName( FILE_NAME.c_str() );

        NAMES a = driveDirectoryBase(pathName);
        std::string root = a.name[1];
        std::string directory = a.name[2];
        path = root + directory;

        const AnsiString ROOT_DIRECTORY( path.c_str() );
        Memo1->Text = ROOT_DIRECTORY;
    }

}

NAMES driveDirectoryBase(std::string & s) {
    using namespace std;

    const string EMPTY = "";
    const string SLASH = "/";
    const string YEN = "\\";
    int firstTrace, trace, w;
    int s_length = s.length();
    string c;

    NAMES part, undivided;
    part.name[0] = EMPTY; part.name[1] = EMPTY; part.name[2] = EMPTY; part.name[3] = EMPTY;
    undivided.name[0] = EMPTY; undivided.name[1] = EMPTY; undivided.name[2] = EMPTY; undivided.name[3] = EMPTY;

    part.name[0] = s; // s.length > 0; in other words, part.name[0].length > undivided.name[0].length

// s is divided into three parts: drive name, directory name, and base name.
    int k = 0;
    for( ; k < s_length; ++k) {
        c = s.substr(k, 1);
        if(c == YEN) {
            part.separator = YEN;
            break;
        } else if(c == SLASH) {
            part.separator = SLASH;
            break;
        }

    }

    if(k == s_length) { // Neither YEN nor SLASH has been found.
        return undivided;
    } else {
        w = k + 1;
        part.name[1] = s.substr(0, w); // C:\ for example
        trace = ++k;
        firstTrace = trace;
    }

    for( ; k < s_length; ++k) {
        c = s.substr(k, 1);
        if(c == part.separator) {
            trace = ++k;
        }

    }

    w = trace - firstTrace;
    part.name[2] = s.substr(firstTrace, w);
    part.name[3] = s.substr(trace); // manage.txt for example
    return part;
}

void __fastcall TOKRightDlg1::Button2Click(TObject *Sender)
{
    executeProgram(HELP_FILE_NAME, ""); // PDF
}

void __fastcall TOKRightDlg1::Label1Click(TObject *Sender)
{
    if(csv) {
        csv = false;
        AnsiString BASE_NAME( RANNU_TEXT.c_str() );
        Label1->Caption = BASE_NAME;
    } else {
        csv = true;
        AnsiString BASE_NAME( RANNU_CSV.c_str() );
        Label1->Caption = BASE_NAME;
    }

    mm->csv = csv;
}

void __fastcall TOKRightDlg1::OKBtnClick(TObject *Sender)
{
    if( readManageText() ) {
        writeManageText();
    }

}
